﻿class CellArea {
	
	private static var MAX_CELL_X:Number = 40;
	private static var MAX_CELL_Y:Number  = 30;
	private static var CELL_SIZE:Number  = 20;
	
	private var cells:Array;
	
	public function CellArea() {
	}
	
	public function initArea():Void {
		this.cells = new Array(MAX_CELL_X);
		for(var i:Number = 0; i < MAX_CELL_X; i++) {
			cells[i] = new Array(MAX_CELL_Y);
			for(var j:Number = 0; j < MAX_CELL_Y; j++) {
				var depth:Number = _root.getNextHighestDepth();
				cells[i][j] = _root.attachMovie("CellMC", "cellMC" + depth, depth);
				cells[i][j]._x = i * CELL_SIZE;
				cells[i][j]._y = j * CELL_SIZE;
				if(Math.random() < 0.25) cells[i][j].setChanged();
			}
		}
		this.performChanges();
	}
	
	public function performChanges():Void {
		for(var i:Number = 0; i < cells.length; i++) {
			var tmpArray:Array = cells[i];
			for(var j:Number = 0; j < tmpArray.length; j++) {
				tmpArray[j].performChange();
			}
		}
	}
	
	public function isAlive(x:Number, y:Number):Boolean {
		if(x >= 0 && x < cells.length) {
			if(y >= 0 && y < cells[x].length) {
				return cells[x][y].isAlive();
			}
		}
		return false;
	}
	
	public function calculateChanges():Void {
		for(var i:Number = 0; i < cells.length; i++) {
			for(var j:Number = 0; j < cells[i].length; j++) {
				var neighbours:Number = 0;
				if(isAlive(i - 1, j - 1)) neighbours++;
				if(isAlive(i - 1, j)) neighbours++;
				if(isAlive(i - 1, j + 1)) neighbours++;
				if(isAlive(i, j - 1)) neighbours++;
				if(isAlive(i, j + 1)) neighbours++;
				if(isAlive(i + 1, j - 1)) neighbours++;
				if(isAlive(i + 1, j)) neighbours++;
				if(isAlive(i + 1, j + 1)) neighbours++;
				if(isAlive(i, j)&& (neighbours < 2 || neighbours > 3)) {
					cells[i][j].setChanged();
				}
				if(!isAlive(i, j) && neighbours == 3) {
					cells[i][j].setChanged();
				}
			}
		}
	}
		
}